ALTER PROCEDURE [dbo].[P_LANGUAGE_CHANGE](@NEWLNG varchar(2)='ru')
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <17.08.2016>
-- Update date: <23.03.2017>
-- Description:	<    >
-- =============================================
SET NOCOUNT ON
SET DATEFORMAT dmy; 
--    
UPDATE PROPERTIES SET LngMain=@NEWLNG;

--   -     ,     
	UPDATE T1 SET T1.CashInName=T2.CashInName,T1.Comments=T2.Comments FROM CashInT T1, CashInTLng T2
		WHERE T1.UNIKEY=T2.UNIKEY AND T2.Lng=@NEWLNG;
	--   
	--INSERT INTO CashInTLng (UNIKEY,Lng,CashInName,Comments)	SELECT UNIKEY,'en',C.CashInName,C.Comments FROM CashInT C WHERE C.IsDefault=1;

--  -     
	UPDATE T1 SET T1.CashName=T2.CashName,T1.Comments=T2.Comments FROM CashType T1, CashTypeLng T2
		WHERE T1.UNIKEY=T2.UNIKEY AND T2.Lng=@NEWLNG;
	-- 
	--INSERT INTO CashTypeLng (UNIKEY,Lng,CashName,Comments)	SELECT UNIKEY,'ru',C.CashName,C.Comments FROM CashType C;

-- -     
	UPDATE T1 SET T1.ChartName=T2.ChartName FROM Charts T1, ChartsLng T2
		WHERE T1.UNIKEY=T2.UNIKEY AND T2.Lng=@NEWLNG;
	-- 
	--INSERT INTO ChartsLng (UNIKEY,Lng,ChartName)	SELECT UNIKEY,'en',C.ChartName FROM Charts C;


--- -     
	UPDATE T1 SET T1.DbKrName=T2.DbKrName FROM DbKr T1, DbKrLng T2
		WHERE T1.UNIKEY=T2.UNIKEY AND T2.Lng=@NEWLNG;
	-- 
	--INSERT INTO DbKrLng (UNIKEY,Lng,DbKrName)	SELECT UNIKEY,'ru',C.DbKrName FROM DbKr C;

--     -     
	UPDATE T1 SET T1.DriverJournalType=T2.DriverJournalType FROM DriverJournalType T1, DriverJournalTypeLng T2
		WHERE T1.UNIKEY=T2.[Key] AND T2.LngKey=@NEWLNG;
	-- 
	--INSERT INTO DriverJournalTypeLng ([KEY],LngKey,DriverJournalType)	SELECT UNIKEY,'en',C.DriverJournalType FROM DriverJournalType C;
	
--  -     
	UPDATE T1 SET T1.DefDisplayName=T2.DefDisplayName,T1.DefHotKey=T2.DefHotKey, T1.Comment=T2.Comment FROM FormActions T1, FormActionsLng T2
		WHERE T1.UNIKEY=T2.UNIKEY AND T2.Lng=@NEWLNG;
	-- 
	--INSERT INTO FormActionsLng (UNIKEY,Lng,DefDisplayName,DefHotKey,Comment)	SELECT UNIKEY,'ru',C.DefDisplayName,DefHotKey,Comment FROM FormActions C;

--    
	UPDATE T1 SET T1.TaksaName=T2.TaksaName,T1.Comment=T2.Comment FROM TaksaType T1, TaksaTypeLng T2
		WHERE T1.UniKey=T2.TaksaType AND T2.LngKey=@NEWLNG;

--  
	UPDATE T1 SET T1.TaskName=T2.TaskName,T1.ParamNote1=T2.ParamNote1,T1.ParamNote2=T2.ParamNote2 FROM Tasks T1, TasksLng T2
		WHERE T1.UniKey=T2.UniKey AND T2.Lng=@NEWLNG;
	--
	--INSERT INTO TasksLng (UNIKEY,Lng,TaskName,ParamNote1,ParamNote2)	SELECT UNIKEY,'en',C.TaskName,ParamNote1,ParamNote2 FROM Tasks C WHERE UniKey<10000;
	--SELECT 'UPDATE TasksLng SET TaskName='''+ISNULL(C.TaskName,'')+''', ParamNote1='''+ISNULL(ParamNote1,'')+''',ParamNote2='''+ISNULL(ParamNote2,'')+''' WHERE UNIKEY='+CAST(UNIKEY as varchar(16))+' AND Lng LIKE ''en''' FROM TasksLng C WHERE Lng LIKE 'en'
	
-- 
	if @NEWLNG='ru' 
		UPDATE USERS SET FIO='' WHERE UniKey=1 OR UniKey=51;
		else
		UPDATE USERS SET FIO='Administrator' WHERE UniKey=1 OR UniKey=51;
--   
	UPDATE T1 SET T1.WebStateName=T2.WebStateName_LNG,T1.PLACE_NAME=T2.PLACE_NAME_LNG FROM ZAKAZ_PLACE T1, ZAKAZ_PLACE_LNG T2
		WHERE T1.ZPLACE=T2.OrderStateKey AND T2.LngKey=@NEWLNG;
-- 
	if @NEWLNG='ru' 
		begin
		UPDATE ZakazExitType SET ZakazExitName=' ' WHERE UniKey=0;
		UPDATE ZakazExitType SET ZakazExitName=' ' WHERE UniKey=1;
		end
		else
		begin
		UPDATE ZakazExitType SET ZakazExitName='successfully completed' WHERE UniKey=0;
		UPDATE ZakazExitType SET ZakazExitName='customer rejection' WHERE UniKey=1;
		end;
-- 
	if @NEWLNG='ru' 
		begin
		UPDATE ZalogT SET NameZalog=' ' WHERE UniKey=1;
		UPDATE ZalogT SET NameZalog=' ' WHERE UniKey=2;
		end
		else
		begin
		UPDATE ZalogT SET NameZalog='collateral acceptance' WHERE UniKey=1;
		UPDATE ZalogT SET NameZalog='pledge returns' WHERE UniKey=2;
		end;		
--   
	if @NEWLNG='ru' 
		begin
		UPDATE PROPERTIES SET GlobalZoneName='', GlobalRegionName='',
			SINGLE_CITY_NAME='', WEB_ENTRANCE_PREFIX='.';
		end
		else
		begin
		UPDATE PROPERTIES SET GlobalZoneName='District', GlobalRegionName='City',
			SINGLE_CITY_NAME='London', WEB_ENTRANCE_PREFIX='e.';
		end;		
--  
	if @NEWLNG='ru' 
		begin
		UPDATE [CarRequirements] SET RequireName='baby chair',ValueName='the child''s age' WHERE RequireName LIKE ' ';
		end
		else
		begin
		UPDATE [CarRequirements] SET RequireName=' ',ValueName=' ' WHERE RequireName LIKE 'baby chair';
		end;
--   
	UPDATE T1 SET T1.[Comment]=T2.[Comment],T1.[DefDisplayName]=T2.[DefDisplayName] FROM [GridPatterns] T1, [GridPatternsLng] T2
		WHERE T1.UniKey=T2.UniKey AND T2.Lng=@NEWLNG;
	UPDATE T1 SET T1.[GroupDisplayName]=T2.[DefDisplayName] FROM [GridPatternsProfile] T1, [GridPatternsLng] T2
		WHERE T1.GridPatterns=T2.UniKey AND T2.Lng=@NEWLNG;
	UPDATE T1 SET T1.[DisplayName]=T2.[DefDisplayName] FROM [GridPatternsUser] T1, [GridPatternsLng] T2
		WHERE T1.GridPatterns=T2.UniKey AND T2.Lng=@NEWLNG;
--
	if @NEWLNG='ru' 
		begin
		UPDATE Colors SET NameColor='' WHERE NameColor LIKE 'white';
		UPDATE Colors SET NameColor='' WHERE NameColor LIKE 'gray';
		end
		else
		begin
		UPDATE Colors SET NameColor='white' WHERE NameColor LIKE '';
		UPDATE Colors SET NameColor='gray' WHERE NameColor LIKE '';
		end;
--
	if @NEWLNG='ru' 
		begin
		UPDATE [Profile] SET ProfileName='' WHERE ProfileName LIKE 'Administrator';
		UPDATE [Profile] SET ProfileName='' WHERE ProfileName LIKE 'Operator';
		UPDATE [Profile] SET ProfileName='' WHERE ProfileName LIKE 'Radio operator';
		UPDATE [Profile] SET ProfileName=' ' WHERE ProfileName LIKE 'Radio operator/Operator';
		end
		else
		begin
		UPDATE [Profile] SET ProfileName='Administrator' WHERE ProfileName LIKE '';
		UPDATE [Profile] SET ProfileName='Operator' WHERE ProfileName LIKE '';
		UPDATE [Profile] SET ProfileName='Radio operator' WHERE ProfileName LIKE '';
		UPDATE [Profile] SET ProfileName='Radio operator/Operator' WHERE ProfileName LIKE ' ';
		end;
		
END