ALTER FUNCTION [dbo].[GetSMSTextByPattern] (@Zakaz int,@PatternUniKey int)
RETURNS varchar(512)  AS	
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <10/12/2011>
-- Update date: <23/02/2017>
-- Description:	<   SMS  1    >
-- =============================================
	DECLARE @GOV_NUMBER varchar(128),@TaxiName varchar(32),@GOV_NUMBER_Short varchar(128),
			 @Price money, @PriceFull money, @StreetTo varchar(32),@StreetFrom varchar(32),
			 @SmsText varchar(512),@PhoneType int, @SMS int,@DriverPhone varchar(20), 
			 @TimeToClient int, @Driver int,@Pattern varchar(512),@hourpay int,@isKmEnabled bit, @PredvTime datetime,
			 @isDiscount bit, @PriceStr varchar(20), @PiramidePoints int,
			 @LatFrom float, @LatTo float, @LonFrom float, @LonTo float, @Dist float;
	SELECT @Pattern=Pattern FROM SMS_Patterns WHERE UniKey=@PatternUniKey;
	SELECT @PredvTime=PREDV_DATETIME, @Driver=Driver, @TIMETOCLIENT=TIMETOCLIENT,@StreetFrom=StreetFrom, 
		@StreetTo=StreetTo, @Price=Price, @hourpay=hourpay,	@isKmEnabled=isKmEnabled, @TaxiName=TaxiName,
		@isDiscount=isDiscount, @PriceFull=PriceFull,@LatFrom=LatFrom,@LonFrom=LonFrom,@PiramidePoints=BL.PiramidePoints
		FROM BASE bbb WITH (readpast) 
		LEFT JOIN LPSrc ON LPSrc.UniKey=bbb.LPSrc 
		LEFT JOIN BLACKLISTTEL BL ON BL.UniKey=bbb.PhoneKey
		WHERE bbb.UNIKEY=@Zakaz;
	SELECT @GOV_NUMBER=GOV_NUMBER,@GOV_NUMBER_Short=GOV_NUMBER_Short FROM Cars WITH (readpast) WHERE UniKey=[dbo].[GetCarByDriver](@DRIVER,GETDATE());
	SET @GOV_NUMBER=isnull(@GOV_NUMBER,'');
	SELECT TOP 1 @DriverPhone=NUMTEL FROM BLACKLISTTEL BLT WITH (readpast)
		INNER JOIN PhoneDrivers PD ON
		BLT.UniKey=PD.PhoneKey WHERE PD.DriverKey=@DRIVER AND PD.isMain=1;
	SET @SmsText=REPLACE(@Pattern,'%FromStreet',isnull(@StreetFrom,''));
	SET @SmsText=REPLACE(@SmsText,'%ToStreet',isnull(@StreetTo,''));

	if @Price!=CAST(@Price as int)
		SET @PriceStr=CONVERT(varchar(32),CAST(@Price as decimal(16,2)));
		else
		SET @PriceStr=CONVERT(varchar(32),CAST(@Price as decimal(16,0)));
			
	SET @SmsText=REPLACE(@SmsText,'%Price',@PriceStr);
	SET @SmsText=REPLACE(@SmsText,'%GovNumber',isnull(@GOV_NUMBER,''));
	SET @SmsText=REPLACE(@SmsText,'%GovNumShort',isnull(@GOV_NUMBER_Short,''));
	SET @SmsText=REPLACE(@SmsText,'%TNAME',isnull(@TaxiName,''));
	SET @DriverPhone=ISNULL(@DriverPhone,'');
	SET @SmsText=REPLACE(@SmsText,'%DriverPhone',@DriverPhone);
	SET @SmsText=REPLACE(@SmsText,'%TimeToClient',CAST(@TIMETOCLIENT as varchar(10)));
	SET @SmsText=REPLACE(@SmsText,'%DiscountPoints',CAST(isnull(@PiramidePoints,0) as varchar(16)));
	
	if (@PredvTime IS NOT NULL)
		begin
		SET @SmsText=REPLACE(@SmsText,'%PredvTime',CAST(CAST(@PredvTime as time) as varchar(5)));
		end
		else
		begin
		SET @SmsText=REPLACE(@SmsText,'%PredvTime','');	
		end;
	if(@isDiscount=1)
		begin		
		SET @SmsText=REPLACE(@SmsText,'%DiscountSum',CAST((isnull(@PriceFull,0)-isnull(@Price,0)) as varchar(16)));	
		SET @SmsText=REPLACE(@SmsText,'%DiscountString',isnull([dbo].[GetOrderDiscountStr](@Zakaz),''));	
		end
		else
		begin
		SET @SmsText=REPLACE(@SmsText,'%DiscountSum','0');	
		SET @SmsText=REPLACE(@SmsText,'%DiscountString','');	
		end;
	--    
	SET @PriceStr='';
	if @Driver IS NOT NULL AND (CHARINDEX('%CarDist',@SmsText)>0)
		begin
		if isnull(@LatFrom,0)!=0 AND ISNULL(@LonFrom,0)!=0
			begin
			SELECT @LatTo=Lat, @LonTo=lon FROM DriversPlace WHERE Driver=@Driver;
			if isnull(@LatTo,0)!=0 AND ISNULL(@LonTo,0)!=0
				begin
				SET @Dist=dbo.F_GPS2M(@LatFrom,@LonFrom,@LatTo,@LonTo)/1000;
				--if(@Dist!=0) 
					begin
					if @Dist!=CAST(@Dist as int)
						SET @PriceStr=CONVERT(varchar(32),CAST(@Dist as decimal(16,2)));
						else
						SET @PriceStr=CONVERT(varchar(32),CAST(@Dist as decimal(16,0)));
					end;
				end;
			end;
		end;
	SET @SmsText=REPLACE(@SmsText,'%CarDist',@PriceStr);	
	-- 
	SET @SmsText=REPLACE(@SmsText,'%CurTime',CAST(CAST(GETDATE() as time) as varchar(8)));
	RETURN(@SmsText)
END