ALTER FUNCTION [dbo].[GetSMSTextByPatternBus] (@BusFlightPassengerKey int,@PatternUniKey int)
RETURNS varchar(512)  AS	
BEGIN
-- ================================================
--%ADDRESS -  
--%Price -   
--%GovNumber -   
--%GovNumShort - c   
--%FIO -   (   )
--%DAY -   ()
--%MONTH -   ()
--%YEAR -   ()
--%TIME -     23:59
--%FNUM -  
--%DiscountPoints -    
-- ================================================
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <21/11/2014>
-- Update date: <23/02/2017>
-- Description:	<   SMS  1    >
-- =============================================
	DECLARE @GOV_NUMBER varchar(128),@ADDRESS varchar(128),@GOV_NUMBER_Short varchar(128),
			 @Price money, @FNUM varchar(128), @TIME varchar(16), @BusFlightKey int,
			 @SmsText varchar(512),@PhoneType int, @SMS int,@FIO varchar(128),@CarKey int,
			 @DateBeginCollecting datetime, @PiramidePoints int,
			 @DAY int, @MONTH int,@YEAR int,@Pattern varchar(512), @PriceStr varchar(20);
	SELECT @Pattern=Pattern FROM SMS_Patterns WHERE UniKey=@PatternUniKey;
	
	SELECT @ADDRESS=BFP.[Address], @BusFlightKey=BFP.BusFlightKey, @FIO=BL.FIO, 
		@CarKey=BF.CarKey, @FNUM=BF.FlightNumber, @DateBeginCollecting=BF.DateBeginCollecting,
		@GOV_NUMBER=GOV_NUMBER,@GOV_NUMBER_Short=GOV_NUMBER_Short, @TIME=BS.TimeTo,
		@Price=(SELECT SUM(Price) FROM BusFlightPassengersDetails WHERE BusFlightPassengersKey=BFP.UniKey),
		@PiramidePoints=BL.PiramidePoints
		FROM BusFlightPassengers BFP WITH (nolock) 	
		LEFT JOIN BusFlights BF ON BF.UniKey=BFP.BusFlightKey
		LEFT JOIN Cars CC ON CC.UniKey=BF.CarKey
		LEFT JOIN BusOutRoutesDetail BS ON BS.UniKey=BFP.BusOutRoutesDetailKey
		LEFT JOIN BLACKLISTTEL BL ON BL.UniKey=BFP.PhoneKey WHERE BFP.UNIKEY=@BusFlightPassengerKey;
	SET @TIME=@DateBeginCollecting+@TIME;
	SET @Price=ISNULL(@Price,0);

	SET @SmsText=REPLACE(@Pattern,'%ADDRESS',isnull(@ADDRESS,''));
	if @Price!=CAST(@Price as int)
		SET @PriceStr=CONVERT(varchar(32),CAST(@Price as decimal(16,2)));
		else
		SET @PriceStr=CONVERT(varchar(32),CAST(@Price as decimal(16,0)));
	
	SET @SmsText=REPLACE(@SmsText,'%Price',@PriceStr);
	SET @SmsText=REPLACE(@SmsText,'%GovNumber',isnull(@GOV_NUMBER,''));
	SET @SmsText=REPLACE(@SmsText,'%GovNumShort',isnull(@GOV_NUMBER_Short,''));
	SET @SmsText=REPLACE(@SmsText,'%FIO',isnull(@FIO,''));
	SET @SmsText=REPLACE(@SmsText,'%FNUM',isnull(@FNUM,''));
	SET @SmsText=REPLACE(@SmsText,'%DiscountPoints',CAST(@PiramidePoints as varchar(16)));
	if @TIME IS NOT NULL
		begin
		SET @DAY=DAY(@TIME);
		SET @MONTH=MONTH(@TIME);
		SET @YEAR=YEAR(@TIME);
		SET @SmsText=REPLACE(@SmsText,'%TIME',CAST(CAST(@TIME as TIME) as varchar(5)));
		SET @SmsText=REPLACE(@SmsText,'%DAY',CAST(@DAY as varchar(10)));
		SET @SmsText=REPLACE(@SmsText,'%YEAR',CAST(@YEAR as varchar(10)));
		SET @SmsText=REPLACE(@SmsText,'%MONTH',CAST(@MONTH as varchar(10)));
		end;
	RETURN(@SmsText)
END
