ALTER PROCEDURE [dbo].[P_HOUSE] (@R int=1, 
@UniKey int=null OUTPUT,		--   
@Street int=null,				-- 
@GeoRegion int=null,			-- /
@House varchar(16)=null,		-- 
@StreetString varchar(128)=null,
@lon float=0,					--
@lat float=0,					--
@isNeedValidate bit=0,			--   
@SelectOrder varchar(1024)=null	--  
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <22.04.2013>
-- Update date: <21.03.2017>
-- Description:	<    >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON;
DECLARE @Q varchar(2000),@TMP int, @ID int=null, @IDProfile int=null, @HouseFromKey int,@DateUpdate datetime;
SET @House=RTRIM(LTRIM(ISNULL(@House,'')));
	if (@R=1)
		begin
		SET @Q='SELECT * FROM COD_HOUSE with(readpast) WHERE 1=1';
		if (@Street IS NOT NULL) SET @Q=@Q+' AND Street='+CAST(@Street as varchar(16));
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY Street,House';
		Exec (@Q);
		return;
		end;
	--
	if (@R=2)
		begin
		SET @DateUpdate=GETDATE();
		UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
		UPDATE COD_HOUSE SET lon=@lon,lat=@lat, House=@House, DateUpdate=@DateUpdate,isNeedValidate=@isNeedValidate
			WHERE UniKey=@UniKey;
		return;
		end;
	--
	if (@R=3)
		begin
		if NOT EXISTS(SELECT * FROM COD_HOUSE with(nolock) WHERE House LIKE @House AND Street=@Street)
			begin
			SET @DateUpdate=GETDATE();
			UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
			INSERT INTO COD_HOUSE (lon,lat, House,Street,isNeedValidate,DateUpdate) 
				VALUES (@lon,@lat, @House,@Street,@isNeedValidate,@DateUpdate);
			SET @UniKey=SCOPE_IDENTITY();
			end
			else SET @UniKey=null;
		return;
		end;
	--
	if (@R=4)
		begin
		UPDATE BASE SET HouseFromKey=NULL WHERE HouseFromKey IN 
			(SELECT UNIKEY FROM COD_HOUSE WHERE ',' + @SelectOrder + ',' like '%,' + cast(UniKey as varchar(10)) + ',%');
		DELETE FROM COD_HOUSE WHERE ',' + @SelectOrder + ',' like '%,' + cast(UniKey as varchar(10)) + ',%';
		SET @DateUpdate=GETDATE();
		UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
		return;
		end;

	--  /  
	if (@R=5)
		begin		
		SET @HouseFromKey=NULL;
		SELECT @HouseFromKey=HouseFromKey,@Street=StreetFromKey, @HOUSE=HouseFrom FROM BASE with(readpast) WHERE UNIKEY=@UniKey;
		--  
		UPDATE BASE SET LatFrom=@Lat,LonFrom=@Lon WHERE UNIKEY=@UniKey;
		-- 
		if @HouseFromKey IS NOT NULL
			begin
			SET @DateUpdate=GETDATE();
			UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
			UPDATE COD_HOUSE SET Lat=@Lat,Lon=@Lon, DateUpdate=@DateUpdate WHERE UniKey=@HouseFromKey;
			return;
			end;
		IF (@Street IS NULL) return;
			--  ,    
			SET @Q=RTRIM(LTRIM(@HOUSE));
			SET @TMP=ISNULL(CHARINDEX(' ',@Q),0);
			if(@TMP>0) SET @Q=SUBSTRING(@Q,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX('.',@Q),0);
			if(@TMP>0) SET @Q=SUBSTRING(@Q,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX(',',@Q),0);
			if(@TMP>0) SET @Q=SUBSTRING(@Q,1,@TMP-1);
			if (LEN(@Q)=0) return;
			--   
			SET @DateUpdate=GETDATE();
			UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
			UPDATE COD_HOUSE SET Lat=@Lat,Lon=@Lon, DateUpdate=@DateUpdate WHERE House LIKE @Q AND Street=@Street;
		return;
		end;
	--   
	if (@R=6)
		begin
			SET @Q=RTRIM(LTRIM(@HOUSE));
			SET @TMP=ISNULL(CHARINDEX(' ',@Q),0);
			if(@TMP>0) SET @Q=SUBSTRING(@Q,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX('.',@Q),0);
			if(@TMP>0) SET @Q=SUBSTRING(@Q,1,@TMP-1);
			SET @TMP=ISNULL(CHARINDEX(',',@Q),0);
			if(@TMP>0) SET @Q=SUBSTRING(@Q,1,@TMP-1);
			SET @UniKey=null;
			SELECT @UniKey=UniKey FROM COD_HOUSE with(nolock) WHERE Street IN 
				(SELECT UniKey FROM COD_STREET with(nolock) WHERE NAME_STREET LIKE @StreetString
					AND (@GeoRegion IS NULL OR Zone in (SELECT UniKey FROM Zone with(nolock) WHERE GeoRegion=@GeoRegion)))
				AND House LIKE @Q;
			SELECT lat,lon,CH.UniKey,CS.ZONE,CH.Street FROM COD_HOUSE CH LEFT JOIN COD_STREET CS ON CH.Street=CS.UNIKEY WHERE CH.UniKey=@UniKey;
		return;
		end;
	-- 
	if (@R=7)
		begin
		SET @DateUpdate=GETDATE();
		UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
		UPDATE COD_HOUSE SET Street=@Street, DateUpdate=@DateUpdate
			where ',' + @SelectOrder + ',' like '%,' + cast(UniKey as varchar(10)) + ',%';
		return;
		end;
	-- ,   
	if (@R=8)
		begin		
		SET @HouseFromKey=NULL;
		SELECT @HouseFromKey=HouseFromKey FROM BASE with(readpast) WHERE UNIKEY=@UniKey;
		-- 
		if @HouseFromKey IS NOT NULL
			begin
			SET @DateUpdate=GETDATE();
			UPDATE TablesLastUpdate SET TLU_HOUSE=@DateUpdate;
			UPDATE COD_HOUSE SET isNeedValidate=0,DateUpdate=@DateUpdate WHERE UniKey=@HouseFromKey;
			end;
		return;
		end;
	--    
	if (@R=9)
		begin
		SELECT TOP 1 @DateUpdate=T.TLU_HOUSE FROM TablesLastUpdate T;
		SET @DateUpdate=DATEADD(mi,-1,@DateUpdate);
		SELECT CH.UniKey,CH.House,CH.lat,CH.lon,CH.Street,ZZ.GeoRegion 
			FROM COD_HOUSE CH 
			LEFT JOIN COD_STREET CS ON CS.UNIKEY=CH.Street 
			LEFT JOIN ZONE ZZ ON ZZ.UNIKEY=CS.ZONE 
			WHERE CH.DateUpdate>=@DateUpdate OR @isNeedValidate=1
		return;
		end;
END
