ALTER PROCEDURE [dbo].[P_LPSrcGeoLink] (@R int=1, @UniKey int=null, @LPSrc int=null, @Pos int=1)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <03.03.2013>
-- Update date: <17.10.2016>
-- Description:	<       >
-- =============================================
SET DATEFORMAT dmy;
	--     
	if @R=1
		begin
		SELECT Pos,GeoRegions.NameGeoRegion,GeoRegions.UniKey
			FROM LPSrcGeoLink LEFT JOIN GeoRegions 
			ON LPSrcGeoLink.GeoRegion=GeoRegions.UniKey WHERE LPSrcGeoLink.LPSrc=@LPSrc ORDER By Pos;
		return;
		end;			
		
	--     
	if @R=2
		begin
		if EXISTS (SELECT * FROM LPSrcGeoLink WHERE GeoRegion=@UniKey AND LPSrc=@LPSrc)
			UPDATE LPSrcGeoLink SET Pos=@Pos WHERE GeoRegion=@UniKey AND LPSrc=@LPSrc;
			ELSE
			INSERT INTO LPSrcGeoLink (GeoRegion,LPSrc,Pos) VALUES (@UniKey,@LPSrc,@Pos);
		UPDATE TablesLastUpdate SET TLU_LPSRC=GETDATE();
		return;
		end;	
	--     
	if @R=3
		begin
		DELETE FROM LPSrcGeoLink WHERE GeoRegion=@UniKey AND LPSrc=@LPSrc;
		UPDATE TablesLastUpdate SET TLU_LPSRC=GETDATE();
		return;
		end;			
	--     -
	if @R=4
		begin
		SELECT LPS.*, GeoRegions.NameGeoRegion FROM LPSrcGeoLink LPS LEFT JOIN GeoRegions 
			ON GeoRegions.UniKey=LPS.GeoRegion ORDER BY Pos ASC;
		return;
		end;
	--     -  WEB 
	if @R=5
		begin
		DECLARE @isSingleCity bit;
		SELECT TOP 1 @isSingleCity=isSingleCity FROM PROPERTIES;
		if(@isSingleCity=1)
			begin
			SELECT LL.UniKey as LPSrc, 0 as GeoRegion, LL.TaxiName, 0 as Pos, LL.WEBPhone,LL.WEBRateDefault,
			LL.LOGOURL,LL.isRequireAddressTo,LL.isWEBCallbackEnabled, LL.isWEBEnabled,LL.isWEBShowPoints,
			LL.WEB_GET_ADDRESS_BY_POS, LL.isWEBShowRoutes, LL.WEB_SMS_DOWNLOAD_PATTERN,
			LL.WEB_SMS_DOWNLOAD_URL, LL.WEB_SMS_DOWNLOAD_URL
				FROM LPSrc LL WITH(READPAST) WHERE LL.isEnabled=1 AND (LL.WEBPhone IS NOT NULL) ORDER BY LL.TaxiName ASC;
			end
			else
			begin
			SELECT LPS.*, LL.TaxiName, LL.WEBPhone,LL.WEBRateDefault,LL.LOGOURL,LL.isRequireAddressTo,LL.isWEBCallbackEnabled,
				LL.isWEBEnabled,LL.isWEBShowPoints,
				LL.WEB_GET_ADDRESS_BY_POS, LL.isWEBShowRoutes, LL.WEB_SMS_DOWNLOAD_PATTERN,
				LL.WEB_SMS_DOWNLOAD_URL, LL.WEB_SMS_DOWNLOAD_URL
			 FROM LPSrcGeoLink LPS WITH(READPAST)  LEFT JOIN LPSrc LL
				ON LL.UniKey=LPS.LPSrc WHERE LL.isEnabled=1 AND (LL.WEBPhone IS NOT NULL) ORDER BY Pos ASC;
			end;
		return;
		end;
END
