ALTER PROCEDURE [dbo].[P_SMS_Pattern] (@R int=1, @UniKey int=NULL OUTPUT,@Pattern varchar(512)=null OUTPUT,
 @PatternType int=null, @SelectOrder varchar(2000)=NULL, @DeviceName varchar(128)=null,
 @DeviceType int=null, @StatusReportRequest bit=null, @MaxSmsLength int=null,@SMSRepeatAfterError int=null,
 @SendGSMCommandTimeInterval int=null, @BaudRate int=null, @CheckNewSMSRate int=null,
 @TimeOut int=null, @serviceCenterAddress varchar(32)=null, @DataLog bit=null,
 @SMSRecieveOnly bit=null, @InitCommand varchar(512)=null, @ServerPort int=null,
@SMPPSourceTon	int=null, @SMPPSourceNPI	int=null, @SMPPDestTon	int=null, @SMPPEnquireLink int=null,
@SMPPDestNPI	int=null, @SMPPBindType	int=null, @OrderSrc int=null,
  @ServerAddress varchar(512)=null, @ServerUserName varchar(128)=null, @ServerPassword varchar(128)=null,
 @PortName varchar(32)=null, @ModuleNumber int=null, @isEnabled bit=null, @COMPortName varchar(16)=null,
 @src_addr varchar(32)=null, @SMSMask varchar(4000)=null)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <03/12/2015>
-- Update date: <23/03/2017>
-- Description:	<  SMS   >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON;
DECLARE @Q varchar(4000), @Pos int,@KeyTmp int, @Prev int;
	if @R=1
		begin
		SET @Q='SELECT sss.*,SPT.TypeName FROM SMS_Patterns sss LEFT JOIN SMS_Patterns_Type SPT ON sss.PatternType=SPT.UniKey AND SPT.Lng LIKE (SELECT TOP 1 LngMain FROM PROPERTIES) WHERE 1=1 ';
		if (@SelectOrder is NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY SPT.TypeName';
--		RaISERROR 99999 @Q;
		Exec (@Q);
		return;
		end;
	if @R=2 /**/
		begin
		UPDATE SMS_Patterns SET Pattern=@Pattern, PatternType=@PatternType WHERE UniKey=@UniKey;
		return;
		end;
	if @R=3 /**/
		begin
		INSERT INTO SMS_Patterns (Pattern,PatternType) VALUES (@Pattern,@PatternType);
		SET @UniKey= SCOPE_IDENTITY();
		return;
		end;
	if @R=4 /*  */
		begin
			if EXISTS(SELECT 1 FROM SMS_Patterns_Link WHERE SMSPattern=@UniKey)
				begin
				SET @Pattern='   .  .';
				end
				else
				begin
				UPDATE BusRouteOutTypes SET SMSPattern=NULL WHERE SMSPattern=@UniKey;
				DELETE FROM SMS_Patterns WHERE UniKey=@Unikey;
				SET @Pattern='';
				end;
		return;
		end;
	if @R=5 /*  */
		begin
			SELECT * FROM SMS_Patterns_Type SPT WHERE SPT.Lng LIKE (SELECT TOP 1 LngMain FROM PROPERTIES);
		return;
		end;
	if @R=6 /*  */
		begin
			SELECT DS.*,CT.ChannelTypeName as mDeviceType
				  FROM DeviceState DS
				  LEFT JOIN [SMSChannelType] CT ON CT.Unikey=DS.DeviceType AND CT.Lng IN (SELECT TOP 1 LngMain from PROPERTIES)
				  ORDER By Pos;
		return;
		end;
	if @R=7 /*    */
		begin
			UPDATE DeviceState SET SMSMask=@SMSMask,ReportPattern=@Pattern,DeviceName=@DeviceName,
				DeviceType=@DeviceType, StatusReportRequest=@StatusReportRequest, 
				MaxSmsLength=@MaxSmsLength,SMSRepeatAfterError=@SMSRepeatAfterError,
				SendGSMCommandTimeInterval=@SendGSMCommandTimeInterval, BaudRate=@BaudRate, 
				CheckNewSMSRate=@CheckNewSMSRate, [TimeOut]=@TimeOut, serviceCenterAddress=@serviceCenterAddress,
				DataLog=@DataLog, SMSRecieveOnly=@SMSRecieveOnly, InitCommand=@InitCommand, ServerPort=@ServerPort,
				ServerAddress=@ServerAddress, ServerUserName=@ServerUserName,
				ServerPassword=@ServerPassword, PortName=@PortName, ModuleNumber=@ModuleNumber,
				isEnabled=@isEnabled, COMPortName=@COMPortName, src_addr=@src_addr,
				SMPPSourceTon=@SMPPSourceTon, SMPPSourceNPI=@SMPPSourceNPI, SMPPDestTon=@SMPPDestTon,
				SMPPEnquireLink=@SMPPEnquireLink,
				SMPPDestNPI=@SMPPDestNPI, SMPPBindType=@SMPPBindType, OrderSrc=@OrderSrc
			 WHERE UniKey=@UniKey;
		return;
		end;
	if @R=8 /*    */
		begin
		SELECT @Pos=MAX(Pos) FROM DeviceState WHERE UniKey=@UniKey;
		SET @Pos=ISNULL(@Pos,0)+1;
			INSERT INTO DeviceState (ReportPattern,
				DeviceType, StatusReportRequest, 
				MaxSmsLength,SMSRepeatAfterError,
				SendGSMCommandTimeInterval, BaudRate, 
				CheckNewSMSRate, [TimeOut], serviceCenterAddress,
				DataLog, SMSRecieveOnly, InitCommand, ServerPort,
				ServerAddress, ServerUserName,
				ServerPassword, PortName, ModuleNumber,
				isEnabled, COMPortName,DeviceName,src_addr,SMSMask,
				SMPPSourceTon, SMPPSourceNPI, SMPPDestTon,	SMPPDestNPI, SMPPBindType, OrderSrc,Pos,SMPPEnquireLink
				) VALUES (@Pattern,
				@DeviceType, @StatusReportRequest, 
				@MaxSmsLength,@SMSRepeatAfterError,
				@SendGSMCommandTimeInterval, @BaudRate, 
				@CheckNewSMSRate, @TimeOut,@serviceCenterAddress,
				@DataLog, @SMSRecieveOnly, @InitCommand, @ServerPort,
				@ServerAddress, @ServerUserName,
				@ServerPassword, @PortName, @ModuleNumber,
				@isEnabled, @COMPortName,@DeviceName,@src_addr,@SMSMask,
				@SMPPSourceTon, @SMPPSourceNPI, @SMPPDestTon,	@SMPPDestNPI, @SMPPBindType,@OrderSrc,@Pos,@SMPPEnquireLink);
		SET @UniKey= SCOPE_IDENTITY();
		return;
		end;
	if @R=9 /*    */
		begin
		DELETE FROM DeviceState 			 WHERE UniKey=@UniKey;		
		return;
		end;
	if @R=10 /*    */
		begin
		SET @KeyTmp =NULL;
		SELECT @Pos=Pos FROM DeviceState WHERE UniKey=@UniKey;
		SELECT TOP 1 @KeyTmp=UniKey, @Prev=Pos FROM DeviceState WHERE Pos<@Pos  ORDER BY Pos DESC;
		if @KeyTmp IS NOT NULL
			begin
				UPDATE DeviceState SET Pos=@Pos WHERE UniKey=@KeyTmp;
				UPDATE DeviceState SET Pos=@Prev WHERE UniKey=@UniKey;
			end;
		return;
		end;
	if @R=11 /*    */
		begin
		SET @KeyTmp =NULL;
		SELECT @Pos=Pos FROM DeviceState WHERE UniKey=@UniKey;
		SELECT TOP 1 @KeyTmp=UniKey, @Prev=Pos FROM DeviceState WHERE Pos>@Pos ORDER BY Pos ASC;
		if @KeyTmp IS NOT NULL
			begin
				UPDATE DeviceState SET Pos=@Pos WHERE UniKey=@KeyTmp;
				UPDATE DeviceState SET Pos=@Prev WHERE UniKey=@UniKey;
			end;
		return;
		end;
	if @R=12 /* */
		begin
		SELECT UniKey,channelTypeName FROM [SMSChannelType] 
			WHERE Lng IN (SELECT TOP 1 LngMain from PROPERTIES)
			ORDER BY channelTypeName;
		return;
		end;
	if @R=13 /*   SMS*/
		begin
			UPDATE SMS SET Channel=NULL WHERE Channel=@Unikey;
			DELETE FROM DeviceState WHERE UniKey=@Unikey;
		return;
		end;
END
