﻿var feature=null;
var route=null;
/*
выбор провайдера для прокладки маршрута
*/
function OSM_ChooseAddr(address_point) {

	OSM_addr_search_remove();
	if(address_point==null) return;
	feature = L.circle( address_point.center, 25, {color: 'green', fill: false}).addTo(OSM_MAP_OBJECT);
	
	var bbox = address_point.bbox;
	if(bbox!=null)
	{
        feature = L.polygon([
             bbox.getSouthEast(),
             bbox.getNorthEast(),
             bbox.getNorthWest(),
             bbox.getSouthWest()
        ]);
		OSM_MAP_OBJECT.addLayer(feature);		
        OSM_MAP_OBJECT.fitBounds(feature.getBounds());
	}
	OSM_MAP_OBJECT.panTo(address_point.center);	
	//OSM_MAP_OBJECT.setZoom(15);
}

//удаляем слой с адресом и маршрутом
function OSM_addr_search_remove() {
	if (feature) 		OSM_MAP_OBJECT.removeLayer(feature);
	if(route) OSM_MAP_OBJECT.removeLayer(route);
}

//выбор провайдера, результат с коллбек
function OSM_GEOCODE_SELECT_PROVADER(Address, callback)
{
	var OSM_Tile_Layer=OSM_Tile_Layers.getCurrentLayerName();
	if(isShowLog) console.log("OSM_Tile_Layer: "+OSM_Tile_Layer);
	if(isShowLog) console.log("OSM_GEOCODE_SELECT_PROVADER: "+Address);
	
	if(OSM_Tile_Layer=="Bing"){
		OSM_PROVIDER = new L.Control.Geocoder.Bing(MAP_KEY_BING);
		OSM_PROVIDER.geocode( Address, function(results) {
			callback(results[0]);
		});
	}
	else
	if(OSM_Tile_Layer=="Google road"){
		OSM_PROVIDER = new L.Control.Geocoder.Google(MAP_KEY_GOOGLE);
		OSM_PROVIDER.geocode( Address, function(results) {
			callback(results[0]);
		});
	}
	else
	if(OSM_Tile_Layer=="Yandex"){
		//тут особая обработка
		ymaps.geocode(Address, {results: 1}).then(function (res) {
					if (res.geoObjects.getLength()) {
						var point = res.geoObjects.get(0);
						var coord=point.geometry.getCoordinates();
						callback({
						name: Address,
						center: new L.LatLng(coord[0], coord[1]),
						bounds: null
						});
					}					
                },
				function (error) {
				// обработка ошибки
				alert("Error yandex map: " + error.message);
		});		
	}
	else
	{
		OSM_PROVIDER = new L.Control.Geocoder.Nominatim();
		OSM_PROVIDER.geocode( Address, function(results) {
			callback(results[0]);
		});
	}
}
//сразу отображение на карте
function OSM_addr_search(Address) {
	OSM_GEOCODE_SELECT_PROVADER(Address,OSM_ChooseAddr);
}

//получаем массив с широтой и долготой
function OSM_GEOCODE_ADDRESS_WITH_CALLBACK(Address,Pos,callback) {
	OSM_GEOCODE_SELECT_PROVADER(Address,function (res) {
		callback(res.center,Pos);
	});
}
//получим массив координат маршрута
var array_latlon=null;
var array_latlon_count=0;
var array_array_string_length=0;
function OSM_CREATE_ADDRESS_ARRAY(AddressStringArray, callback)
{
	array_latlon=null;
	array_latlon=new Array();
	array_latlon_count=0;
	array_array_string_length=AddressStringArray.length;
	for(var i=0;i<AddressStringArray.length;i++)
	{
		if(AddressStringArray[i].LAT!=0){
			array_latlon.push(new L.LatLng(AddressStringArray[i].LAT, AddressStringArray[i].LON));
			array_latlon_count++;
			if(array_latlon_count==array_array_string_length) {
				if(isShowLog) console.log("OSM_CREATE_ADDRESS_ARRAY return data(all points)");
				callback(array_latlon);
			}
		}else
		{
			array_latlon.push(new L.LatLng(null, null));
			OSM_GEOCODE_ADDRESS_WITH_CALLBACK(AddressStringArray[i].ADDR,i,function(result,Pos){
					if(isShowLog) console.log("OSM_CREATE_ADDRESS_ARRAY["+Pos+"]:"+result.lat+" "+result.lng+" count="+array_latlon_count);
					array_latlon[Pos]=result;
					array_latlon_count++;
					if(array_latlon_count==array_array_string_length) {
						if(isShowLog) console.log("OSM_CREATE_ADDRESS_ARRAY return data");
						callback(array_latlon);
					}
				}
			);
		}
	}	
}

//decode compressed route geometry
function OSRM_decode(encoded, precision) {
precision = Math.pow(10, -precision);
var len = encoded.length, index=0, lat=0, lng = 0, array = [];
while (index < len) {
var b, shift = 0, result = 0;
do {
b = encoded.charCodeAt(index++) - 63;
result |= (b & 0x1f) << shift;
shift += 5;
} while (b >= 0x20);
var dlat = ((result & 1) ? ~(result >> 1) : (result >> 1));
lat += dlat;
shift = 0;
result = 0;
do {
b = encoded.charCodeAt(index++) - 63;
result |= (b & 0x1f) << shift;
shift += 5;
} while (b >= 0x20);
var dlng = ((result & 1) ? ~(result >> 1) : (result >> 1));
lng += dlng;
//array.push( {lat: lat * precision, lng: lng * precision} );
array.push( [lat * precision, lng * precision] );
}
return array;
}
